"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const ad_record_1 = require("../records/ad.record");
const db_1 = require("../utils/db");
const defaultObj = {
    name: "Test Name",
    description: "blah blah blah...",
    price: 0,
    url: "https://megak.pl",
    lat: 9,
    lon: 9,
};
afterAll(() => __awaiter(void 0, void 0, void 0, function* () {
    yield db_1.pool.end();
}));
test('MSG FROM TEST AdRecord returns data from database for one entry', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield ad_record_1.AdRecord.getOne('abc');
    // console.log(ad);
    expect(ad).toBeDefined(); //czy istnieje
    expect(ad.id).toBe('abc');
    expect(ad.name).toBe('Testowa');
    //...dopisz testy do sprawdzanie pojedynczych wartosci, nie jest to niezbedne, ale zeby pocwiczyc to warto
}));
// jak czegos nie ma to zeby zwracalo nulla
test('MSG FROM TEST AdRecord.getOne returns null from db for non existing entry', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = yield ad_record_1.AdRecord.getOne('---'); //getOne w bazie nie ma dlatego test  wywalali
    expect(ad).toBeNull(); // czy id jest 'abc' jak w bazie
}));
test('MSG FROM TEST AdRecord.findAll returns array of found entries', () => __awaiter(void 0, void 0, void 0, function* () {
    const ads = yield ad_record_1.AdRecord.findAll('');
    expect(ads).not.toEqual([]);
    expect(ads[0].id).toBeDefined();
}));
test('MSG FROM TEST AdRecord.findAll returns array of found "a"', () => __awaiter(void 0, void 0, void 0, function* () {
    const ads = yield ad_record_1.AdRecord.findAll('a');
    expect(ads).not.toEqual([]);
    expect(ads[0].id).toBeDefined();
}));
test('MSG FROM TEST AdRecord.findAll returns empty array searching for non existing thing', () => __awaiter(void 0, void 0, void 0, function* () {
    const ads = yield ad_record_1.AdRecord.findAll('------------');
    expect(ads).toEqual([]);
}));
test('MSG FROM TEST AdRecord.findAll returns small ammount of data', () => __awaiter(void 0, void 0, void 0, function* () {
    const ads = yield ad_record_1.AdRecord.findAll('');
    expect(ads[0].price).toBeUndefined();
    expect(ads[0].description).toBeUndefined();
}));
test('MSG FROM TESTI AdRecord.insert returns uuid', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = new ad_record_1.AdRecord(defaultObj);
    yield ad.insert();
    expect(ad.id).toBeDefined();
    expect(typeof ad.id).toBe('string');
}));
test('MSG FROM TESTI AdRecord.insert inserts data to db', () => __awaiter(void 0, void 0, void 0, function* () {
    const ad = new ad_record_1.AdRecord(defaultObj);
    yield ad.insert();
    const foundAd = yield ad_record_1.AdRecord.getOne(ad.id);
    expect(foundAd).toBeDefined();
    expect(foundAd).not.toBeNull();
    expect(foundAd.id).toBe(ad.id);
}));
//# sourceMappingURL=ad.test.js.map